<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:a4j="http://richfaces.org/a4j"
	xmlns:rich="http://richfaces.org/rich"
	xmlns:c="http://java.sun.com/jsp/jstl/core"
	xmlns:notifications="http://java.sun.com/jsf/composite/components/org/inra/ecoinfo/notifications"
	xmlns:identification="http://java.sun.com/jsf/composite/components/org/inra/ecoinfo/identification"
	xmlns:popups="http://java.sun.com/jsf/composite/components/org/inra/ecoinfo/popups">
	<h:outputStylesheet library="css" name="extraction/#{css}" />
	
	<a4j:jsFunction name="selectTaxonVO" execute="@this,parametersRequest" action="#{uiBean.selectTaxonVO}" 
	    render="tree,listTaxons,parametersRequest, nextStepButton,messageWarningStep3" limitRender="true">
		<a4j:param name="param1" assignTo="#{uiBean.idTaxonVOSelected}" />
	</a4j:jsFunction>
	
	<a4j:jsFunction name="updateTaxonList" execute="@this,parametersRequest" action="#{uiBean.updateTaxonList}" 
	    render="rechercheLibre,parametersRequest,messageWarningStep3" limitRender="true">
	    <a4j:param name="param1" assignTo="#{uiBean.taxonSearch}" />
	</a4j:jsFunction>
	
	<a4j:jsFunction name="updateList" execute="@this,parametersRequest" action="#{uiBean.updateList}" 
	    render="panelLength,lenghtList,parametersRequest,messageWarningStep3, and, or" limitRender="true">
	</a4j:jsFunction>
	
	<a4j:jsFunction name="changeFilter" execute="@this,parametersRequest" action="#{uiBean.changeFilter}" 
	    render="panelLength,lenghtList,parametersRequest,messageWarningStep3, and, or" limitRender="true">
	    <a4j:param name="param1" assignTo="#{uiBean.filter}" />
	</a4j:jsFunction>
	
	<a4j:jsFunction name="updateLengthList" execute="@this,parametersRequest" action="#{uiBean.updateLengthList}" 
	    render="parametersRequest,messageWarningStep3,lenghtList" limitRender="true">
	    <a4j:param name="param1" assignTo="#{uiBean.lengthValue}" />
	    <a4j:param name="param2" assignTo="#{uiBean.lengthOrder}" />
	</a4j:jsFunction>
	
	<a4j:jsFunction name="updateBiovolumeList" execute="@this,parametersRequest" action="#{uiBean.updateBiovolumeList}" 
	    render="parametersRequest,messageWarningStep3,lenghtList" limitRender="true">
	    <a4j:param name="param1" assignTo="#{uiBean.biovolumeValue}" />
	    <a4j:param name="param2" assignTo="#{uiBean.biovolumeOrder}" />
	</a4j:jsFunction>

	<f:loadBundle
	basename="org.inra.ecoinfo.glacpe.extraction.jsf.panels.phytoplancton.taxonchoicestep"
	var="taxonchoicestep" />
	
	<h:panelGroup id="messageWarningStep3" >
			<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_CHOOSE_TAXON}"
				 rendered="#{not uiBean.parametersRequest.taxonStepIsValid}" styleClass="selectionEmpty" />
	</h:panelGroup>

	<h:panelGroup styleClass="panelControlsWrapper-taxa" layout="block">
		<h:panelGroup styleClass="panelControls">
			<h:panelGroup styleClass="control" id="panelGenre">
				<h:selectBooleanCheckbox id="genreBox" value="#{uiBean.genre}"
					title="#{taxonchoicestep.PROPERTY_MSG_SEARCH_GENDER_TITLE}">
					<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_SEARCH_GENDER}" />
					<a4j:ajax event="click" execute="@this" render="panelGenre, lenghtList, rechercheLibre"
						status="statusWaitModal"/>
				</h:selectBooleanCheckbox>
			</h:panelGroup>
			<h:panelGroup styleClass="control">
				<a4j:commandLink execute="@this,parametersRequest,tree,treePreselection" styleClass="buttonStepNext" limitRender="true" action="#{uiBean.addAllTaxons}"
					render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree, panelSomme, panelDetail">
					<h:graphicImage value="#{resource['images:add.png']}" />
					<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_ALL_TAXON}" />
				</a4j:commandLink>
			</h:panelGroup>
			<h:panelGroup styleClass="control">
				<a4j:commandLink execute="@this,parametersRequest,tree" styleClass="buttonStepNext" limitRender="true"
					action="#{uiBean.removeAllTaxons}"
					render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree">
					<h:graphicImage value="#{resource['images:remove_selection.png']}" />
					<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_CLEAR_SELECT}" />
				</a4j:commandLink>
			</h:panelGroup>
		</h:panelGroup>
	
		<h:panelGroup styleClass="panelControlsLeft" >
			<h:panelGroup styleClass="control" id="panelSomme">
				<h:selectBooleanCheckbox id="sommationBox" value="#{uiBean.sommation}"
					title="#{taxonchoicestep.PROPERTY_MSG_TAXON_SUM_BRANCHE_TITLE}">
					<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_SUM_BRANCHE}" />
					<a4j:ajax event="click" execute="@this" render="panelSomme"/>
				</h:selectBooleanCheckbox>
			</h:panelGroup>
			<br />
			<h:panelGroup styleClass="control" id="panelDetail">
				<h:selectBooleanCheckbox id="detailBox" value="#{uiBean.detail}"
					title="#{taxonchoicestep.PROPERTY_MSG_DETAIL_BRANCHE_TITLE}">
					<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_DETAIL_BRANCHE}" />
					<a4j:ajax event="click" execute="@this" render="panelDetail"/>
				</h:selectBooleanCheckbox>
			</h:panelGroup>	
			<br />
			<h:panelGroup styleClass="control" id="panelProprieteTaxon">
				<h:selectBooleanCheckbox id="genreProprieteTaxon" value="#{uiBean.propriete}"
					title="#{taxonchoicestep.PROPERTY_MSG_ADD_TAXON_PROPERTY_TITLE}">
					<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_ADD_TAXON_PROPERTY}" />
					<a4j:ajax event="click" execute="@this" render="panelProprieteTaxon" />
				</h:selectBooleanCheckbox>
			</h:panelGroup>
		</h:panelGroup>
	</h:panelGroup>
	
	<rich:tabPanel switchtype="client" id="listTaxons" styleClass="panelTaxons">
		<rich:tab header="#{taxonchoicestep.PROPERTY_MSG_TAXON_PRESELECT}">			
			<h:panelGroup id="preselectionTaxons" styleClass="listVariables">
				<rich:tree id="treePreselection" var="node" toggleType="client" binding="#{uiBean.treePreselectionListTaxons}" selectionType="ajax">
					<rich:treeModelRecursiveAdaptor roots="#{uiBean.preselectionRootNodes}" nodes="#{node.algalChildren}">
						<rich:treeNode binding="#{uiBean.treeNodePreselection}" expanded="#{node.expanded}" >
							<a4j:commandLink action="#{uiBean.deployNodeAlgal}" execute="@this,parametersRequest" limitRender="true"
								render="treePreselection,parametersRequest,nextStepButton">
								<f:setPropertyActionListener target="#{uiBean.treeNodeAlgalSelected}" value="#{node}" />
							#{node.algalClass.nom}				
							</a4j:commandLink>
							<h:graphicImage name="check.png" library="images" rendered="#{node.algalClass.selected}" />
						</rich:treeNode>
						<rich:treeModelAdaptor nodes="#{node.children}" >
							<rich:treeNode>
								<a4j:commandLink action="#{uiBean.deployNodeTaxon}" execute="@this,parametersRequest" limitRender="true"
									render="treePreselection,parametersRequest,nextStepButton" styleClass="leaf">
									<f:setPropertyActionListener target="#{uiBean.treeNodeTaxonSelected}" value="#{node}" />
								#{node.taxon.localizedName}				
								</a4j:commandLink>
								<h:graphicImage name="check.png" library="images" rendered="#{node.taxon.selected}" />
							</rich:treeNode>
						</rich:treeModelAdaptor>
					</rich:treeModelRecursiveAdaptor>
				</rich:tree>
			</h:panelGroup>
		</rich:tab>
		<rich:tab header="#{taxonchoicestep.PROPERTY_MSG_FREE_SEARCH}">
			<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_SEARCH_BY_NAME}" />
			<h:inputText value="#{uiBean.taxonSearch}" onkeyup="updateTaxonList(this.value)" />
			<h:panelGroup styleClass="panelControlsWrapper" layout="block">
				<h:panelGroup styleClass="panelControls" >
					<h:panelGroup styleClass="control" id="panelFreeSearch">
						<a4j:commandLink execute="@this,parametersRequest,tree,treePreselection" styleClass="buttonStepNext" limitRender="true" action="#{uiBean.addFreeTaxon}"
							render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree">
							<h:graphicImage value="#{resource['images:add.png']}" />
							<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_LIST_TAXON}" />
						</a4j:commandLink>
					</h:panelGroup>
				</h:panelGroup>
			</h:panelGroup>
			<rich:list value="#{uiBean.taxonsAvailables}" var="taxon" id="rechercheLibre">
				<h:outputLink value="#" onclick="selectTaxonVO(#{taxon.taxon.id})" rendered="true">
					<h:outputText value="#{taxon.localizedName} (#{taxon.localizedLevelName})" styleClass="#{taxon.selected ? 'selected':''}" />
					<h:graphicImage name="check.png" library="images" rendered="#{taxon.selected}" />
				</h:outputLink>
	
				<h:outputText value="#{taxon.localizedName} (#{taxon.localizedLevelName})" rendered="false" styleClass="disabled" />	
			</rich:list>	
		</rich:tab>
		<rich:tab header="#{taxonchoicestep.PROPERTY_MSG_SEARCH_BY_HEIGHT}">
			<h:panelGroup layout="block" styleClass="wrapper" id="panelLength">
				<h:selectBooleanCheckbox value="#{uiBean.choiceLength}" id="choiceLength">
					<a4j:ajax event="change" oncomplete="updateList()" render="panelLength, lenghtList" execute="panelLength" />
				</h:selectBooleanCheckbox>
				<h:outputLabel value="#{taxonchoicestep.PROPERTY_MSG_HEIGHT_BETWEEN}"
					for="choiceLength" />
				<h:inputText id="minLength" value="#{uiBean.minLength}" onkeyup="updateLengthList(this.value,'min')" disabled="#{not uiBean.choiceLength}" />
				<h:outputText value="µm " /><h:outputText value="#{taxonchoicestep.PROPERTY_MSG_AND}" />
				<h:inputText id="maxLength" value="#{uiBean.maxLength}" onkeyup="updateLengthList(this.value,'max')" disabled="#{not uiBean.choiceLength}" />
				<h:outputText value="µm" />
			</h:panelGroup>
			<input type="radio" id="or"
				name="choice" value="#{taxonchoicestep.PROPERTY_MSG_OR}"
				checked="#{uiBean.filter?'':'checked'}"
				onchange="changeFilter(false)" />
			<label for="or"> <h:outputText value="#{taxonchoicestep.PROPERTY_MSG_OR}" /> </label>
			<input type="radio" id="and"
				name="choice" value="#{taxonchoicestep.PROPERTY_MSG_AND}"
				checked="#{uiBean.filter?'checked':''}"
				onchange="changeFilter(true)" />
			<label for="and"> <h:outputText	value="#{taxonchoicestep.PROPERTY_MSG_AND}" /> </label>
			<h:panelGroup layout="block" styleClass="wrapper" id="panelBiovolume" >
				<h:selectBooleanCheckbox value="#{uiBean.choiceBiovolume}" id="choiceBiovolume">
					<a4j:ajax event="change" oncomplete="updateList()" render="panelBiovolume, lenghtList" execute="panelBiovolume" />
				</h:selectBooleanCheckbox>
				<h:outputLabel value="#{taxonchoicestep.PROPERTY_MSG_BIOVOLUME_BETWEEN}"
					for="choiceBiovolume" />
				<h:inputText id="minBiov" value="#{uiBean.minBiovolume}" onkeyup="updateBiovolumeList(this.value,'min')" disabled="#{not uiBean.choiceBiovolume}" />
				<h:outputText value="µm" />
				<sup>3 </sup> 
				<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_AND}" />
				<h:inputText id="maxBiov" value="#{uiBean.maxBiovolume}" onkeyup="updateBiovolumeList(this.value,'max')" disabled="#{not uiBean.choiceBiovolume}" />
				<h:outputText value="µm" />
				<sup>3</sup> 
			</h:panelGroup>
			<h:panelGroup styleClass="panelControlsWrapper" layout="block">
				<h:panelGroup styleClass="panelControls" >
					<h:panelGroup styleClass="control" id="panelLengthBiovolume">
						<a4j:commandLink execute="@this,parametersRequest,tree,treePreselection" styleClass="buttonStepNext" limitRender="true" action="#{uiBean.addListTaxon}"
							render="listTaxons,parametersRequest, prevStepButton, nextStepButton, validImage, messageWarningStep3,tree">
							<h:graphicImage value="#{resource['images:add.png']}" />
							<h:outputText value="#{taxonchoicestep.PROPERTY_MSG_LIST_TAXON}" />
						</a4j:commandLink>
					</h:panelGroup>
				</h:panelGroup>
			</h:panelGroup>
			<h:panelGroup layout="block" styleClass="wrapper">
				<rich:list value="#{uiBean.taxonsLengthAvailables}" var="taxon" id="lenghtList">
					<h:outputLink value="#" onclick="selectTaxonVO(#{taxon.taxon.id})" rendered="true">
						<h:outputText value="#{taxon.localizedName} (#{taxon.localizedLevelName})" styleClass="#{taxon.selected ? 'selected':''}" />
						<h:graphicImage name="check.png" library="images" rendered="#{taxon.selected}" />
					</h:outputLink>
		
					<h:outputText value="#{taxon.localizedName} (#{taxon.localizedLevelName})" rendered="false" styleClass="disabled" />	
				</rich:list>
			</h:panelGroup>
		</rich:tab>
		<rich:tab header="#{taxonchoicestep.PROPERTY_MSG_TAXON_TREE}">
			<rich:tree id="tree" var="node" toggleType="client" binding="#{uiBean.treeListTaxon}" selectionType="ajax" >
				<rich:treeModelRecursiveAdaptor roots="#{uiBean.rootNodes}" nodes="#{node.children}">
					<rich:treeNode binding="#{uiBean.treeNodeTaxon}" expanded="#{node.expanded}" >
						<a4j:commandLink value="#{node.taxon == null? taxonchoicestep.PROPERTY_MSG_TREE_PHYTO:node.taxon.localizedName}" 
							action="#{uiBean.deployNodeTaxon}" execute="@this,parametersRequest" limitRender="true"
							render="tree,parametersRequest,messageWarningStep3,taxonStepValid,nextStepButton">
							<f:setPropertyActionListener target="#{uiBean.treeNodeTaxonSelected}" value="#{node}" />		
						</a4j:commandLink>
						<h:graphicImage name="check.png" library="images" rendered="#{node.taxon.selected}" />
					</rich:treeNode>
					<rich:treeModelAdaptor nodes="#{node.leaves}" >
						<rich:treeNode>
							<a4j:commandLink value="#{node.taxon.localizedName}" action="#{uiBean.deployNodeTaxon}" execute="@this,parametersRequest" limitRender="true"
								render="tree,parametersRequest,messageWarningStep3,taxonStepValid,nextStepButton" styleClass="leaf">
								<f:setPropertyActionListener target="#{uiBean.treeNodeTaxonSelected}" value="#{node}" />					
							</a4j:commandLink>
							<h:graphicImage name="check.png" library="images" rendered="#{node.taxon.selected}" />
						</rich:treeNode>
					</rich:treeModelAdaptor>
				</rich:treeModelRecursiveAdaptor>
			</rich:tree>
		</rich:tab>
		
	</rich:tabPanel>
	
</html>